/* -------------------------------------------------------------------------- */
/* $Id: gomp_support.h,v 1.1 2005/01/17 19:56:07 Jacob_Weismann_Poulsen Exp $ */
/* -------------------------------------------------------------------------- */

#ifndef _GOMP_H
#define _GOMP_H

#ifdef __cplusplus
extern "C" {
#endif

#define NUM_THREADS 4
#define DEFAULT_CHUNK 4

/* FIXME.  DOCUMENT.  */
enum _OMP_indextype
{
    INDEXTYPE_SHORT,
    INDEXTYPE_INT,
    INDEXTYPE_LONG
};

/* FIXME.  DOCUMENT.  */
enum _OMP_schedule_kind
{
	DEFAULT,
	DYNAMIC, 
	GUIDED, 
	RUNTIME, 
	STATIC
};

/* FIXME.  DOCUMENT.  */
typedef struct t_OMP_state 
{
	enum _OMP_schedule_kind schedule;
	int chunksize;
} _OMP_state;

/* FIXME.  DOCUMENT.  */
typedef struct t_OMP_ParRegion_Info {
	void *(*func)(void*);
	long lower;
	long upper;
	long step;
	long chunksize;
	enum _OMP_schedule_kind schedule;
    enum _OMP_indextype indextype;
} _OMP_ParRegion_Info;

/* FIXME.  DOCUMENT.  */
typedef struct t_OMP_Thread_Args {
	int thread_id;
	void *args;
	pthread_mutex_t lock;
} _OMP_Thread_Args;

/* FIXME.  DOCUMENT.  */
typedef struct _OMP_loop_long {
	pthread_mutex_t	mutex;
	long            lower;
	long            upper;
	long            step;
	long            chunk;
	int             done; 
	enum _OMP_schedule_kind schedule;
} _OMP_loop_long_t;

extern void _OMP_init(void);
extern void _OMP_destroy(void);

extern void	_OMP_PrivateVars(void *copyin_arg);
extern void _OMP_MasterFunction(_OMP_ParRegion_Info *master_thread, 
		void *arg, int par_cond, void *copyin_arg);
extern void _OMP_LoopInit(_OMP_ParRegion_Info *_pr_i);
extern void _OMP_LoopInit_long(_OMP_ParRegion_Info *_pr_i);
extern long _OMP_GetNextChunk_long(long *my_lower, long *my_upper);
extern void _OMP_WorkSharing(_OMP_ParRegion_Info *o_pr_i, void *arg, 
		int nowait) ;

extern void _gomp_error(void);
extern void TRACE (unsigned int module, unsigned int level, 
		const char *format, ...);
extern void SET_TRACE_LEVEL (unsigned int module, unsigned int level);

extern int omp_get_thread_num (void);
extern int omp_get_num_threads(void);

/* -------------------------------------------------------------------------- */
/* GOMP trace BEGIN                                                           */

#define TRACE_BIT_0  0x00000001
#define TRACE_BIT_1  0x00000010
#define TRACE_BIT_2  0x00000100
#define TRACE_BIT_3  0x00001000
#define TRACE_BIT_4  0x00010000
#define TRACE_BIT_5  0x00100000
#define TRACE_BIT_6  0x01000000
#define TRACE_BIT_7  0x10000000
/* Alias tracebit to a certain code-stub. Add aliases when needed */
#define GOMP_SUPPORT TRACE_BIT_0
#define GOMP_OMPLIB TRACE_BIT_1
#define GOMP_LOOP TRACE_BIT_2
#define SAMPLE0 TRACE_BIT_3
#define SAMPLE1 TRACE_BIT_4
#define SAMPLE2 TRACE_BIT_5
#define SAMPLE3 TRACE_BIT_6


#ifdef __cplusplus
}
#endif

#endif /* _GOMP_H */
